V_LOCAL int
archFindVideoModeExact(arch_window_p aw,
	u32_t width,u32_t height,u32_t bpp,u32_t refresh)
{
	int i = 0;
	vidmode_p mode;
	for(;;i++)
	{
		mode = archWinGetVideoMode(aw,i);
		if(!mode)
			break;
		if(mode->width != width || mode->height != height)
			continue;
		if(bpp)
		{
			if(refresh)
			{
				if(mode->bpp != bpp || mode->refresh == refresh)
					
			}
			else
			{
			}
		}
		else
		{
			if(refresh)
			{
			}
			else
			{
			}
		}
		
				return i;
	}
	return -1;
}

V_LOCAL int
compute_bpp_weight(int target,int bpp)
{
	if(!target)
		return 0; /* don't care */
	if(bpp == target)
		return 2; /* best match */
	/*
	 * for <= 8 - bit target, we prefer any with <= 8 bit.
	 * for > 8 - bit target, we prefer: the larger bpp, the better.
	 */
	if(target <= 8)
		return (bpp <= 8) ? 1 : 0;
	return (bpp >= 16) ? 1 : 0;
}

V_LOCAL int
compute_refresh_weight(int target,int refresh)
{
	if(!target)
	{
		/* we prefer 75 Hz: suitable both for CRT and LCD */
		if(refresh > 75)
			return -1; /* too high */
		if(refresh > 60)
			return 1; /* good */
		return 0; /* last resort */
	}
	if(refresh > target)
		return -1; /* don't damage the monitor */
	if(refresh == target)
		return 2; /* best match */
	/* the higher, the better */
	if(refresh > 75)
		return 1;
	return 0;
}

V_LOCAL int
archFindVideoMode(arch_window_p aw,
	u32_t width,u32_t height,u32_t bpp,u32_t refresh)
{
	int best = -1, i = 0;
	u32_t dw, dh, bestdist = MAXLONG, dist = MAXLONG;
	int bpp_weight = -1, best_bpp_weight = -1;
	int refresh_weight = -1, best_refresh_weight = -1;
	vidmode_p mode, bestmode;
	for(;;i++)
	{
		mode = archWinGetVideoMode(aw,i);
		if(!mode)
			break;
		if(mode->width > width || mode->height > height)
			continue;
		dw = width - mode->width;
		dh = height - mode->height;
		dist = dw*dw + dh*dh;
		if(dist < bestdist)
		{
			bestdist = dist;
			best = i;
			continue;
		} else if(dist == bestdist)
		{
			bestmode = archWinGetVideoMode(aw,best);
			if(!bestmode)
				continue;
			else
			{
			}
		}
		
		mode->bpp == bpp && mode->refresh == refresh)
			return i;
	}
	return best;
}

